import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { AppUser, AppUserParam } from '@/api/app/user/model/index';

/**
 * 分页查询开发成员
 */
export async function pageAppUser(params: AppUserParam) {
  const res = await request.get<ApiResult<PageResult<AppUser>>>(
    '/oa/app-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询开发成员列表
 */
export async function listAppUser(params?: AppUserParam) {
  const res = await request.get<ApiResult<AppUser[]>>('/oa/app-user', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询开发成员
 */
export async function getAppUser(id: number) {
  const res = await request.get<ApiResult<AppUser>>('/oa/app-user/' + id);
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加开发成员
 */
export async function addAppUser(data: AppUser) {
  const res = await request.post<ApiResult<unknown>>('/oa/app-user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改开发成员
 */
export async function updateAppUser(data: AppUser) {
  const res = await request.put<ApiResult<unknown>>('/oa/app-user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除开发成员
 */
export async function removeAppUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/oa/app-user/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除开发成员
 */
export async function removeBatchAppUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/oa/app-user/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>('/oa/app-user/existence', {
    params: { field, value, id }
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
